Index: trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp
===================================================================
--- trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp	(revision 253)
+++ trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp	(revision 273)
@@ -1,7 +1,7 @@
  /* -*- c++ -*-
- * File 	: vci_mem_cache_v4.cpp
- * Date 	: 30/10/2008
- * Copyright 	: UPMC / LIP6
- * Authors 	: Alain Greiner / Eric Guthmuller
+ * File       : vci_mem_cache_v4.cpp
+ * Date       : 30/10/2008
+ * Copyright  : UPMC / LIP6
+ * Authors    : Alain Greiner / Eric Guthmuller
  *
  * SOCLIB_LGPL_HEADER_BEGIN
@@ -26,4 +26,5 @@
  *
  * Maintainers: alain eric.guthmuller@polytechnique.edu
+ *              cesar.fuguet-tortolero@lip6.fr
  */
 
@@ -32,23 +33,23 @@
 //////   debug services   ///////////////////////////////////////////////////////
 // All debug messages are conditionned by two variables:
-// - compile time : DEBUG_MEMC_*** : defined below
-// - execution time : m_debug_***  : defined by constructor arguments
+// - compile time   : DEBUG_MEMC_*** : defined below
+// - execution time : m_debug_***    : defined by constructor arguments
 //    m_debug_* = (m_debug_ok) and (m_cpt_cycle > m_debug_start_cycle)
 /////////////////////////////////////////////////////////////////////////////////
 
-#define DEBUG_MEMC_GLOBAL	0	// synthetic trace of all FSMs
-#define DEBUG_MEMC_READ 	1	// detailed trace of READ FSM
-#define DEBUG_MEMC_WRITE	1	// detailed trace of WRITE FSM	
-#define DEBUG_MEMC_SC 		1	// detailed trace of SC FSM	
-#define DEBUG_MEMC_IXR_CMD	1	// detailed trace of IXR_RSP FSM
-#define DEBUG_MEMC_IXR_RSP	1	// detailed trace of IXR_RSP FSM
-#define DEBUG_MEMC_XRAM_RSP	1	// detailed trace of XRAM_RSP FSM	
-#define DEBUG_MEMC_INIT_CMD	1	// detailed trace of INIT_CMD FSM	
-#define DEBUG_MEMC_INIT_RSP	1	// detailed trace of INIT_RSP FSM	
-#define DEBUG_MEMC_TGT_CMD	1	// detailed trace of TGT_CMD FSM	
-#define DEBUG_MEMC_TGT_RSP	1	// detailed trace of TGT_RSP FSM	
-#define DEBUG_MEMC_CLEANUP	1	// detailed trace of CLEANUP FSM	
-
-#define RANDOMIZE_SC		1
+#define DEBUG_MEMC_GLOBAL   0 // synthetic trace of all FSMs
+#define DEBUG_MEMC_READ     1 // detailed trace of READ FSM
+#define DEBUG_MEMC_WRITE    1 // detailed trace of WRITE FSM
+#define DEBUG_MEMC_SC       1 // detailed trace of SC FSM
+#define DEBUG_MEMC_IXR_CMD  1 // detailed trace of IXR_RSP FSM
+#define DEBUG_MEMC_IXR_RSP  1 // detailed trace of IXR_RSP FSM
+#define DEBUG_MEMC_XRAM_RSP 1 // detailed trace of XRAM_RSP FSM
+#define DEBUG_MEMC_INIT_CMD 1 // detailed trace of INIT_CMD FSM
+#define DEBUG_MEMC_INIT_RSP 1 // detailed trace of INIT_RSP FSM
+#define DEBUG_MEMC_TGT_CMD  1 // detailed trace of TGT_CMD FSM
+#define DEBUG_MEMC_TGT_RSP  1 // detailed trace of TGT_RSP FSM
+#define DEBUG_MEMC_CLEANUP  1 // detailed trace of CLEANUP FSM
+
+#define RANDOMIZE_SC        1
 
 namespace soclib { namespace caba {
@@ -58,5 +59,5 @@
     "TGT_CMD_READ",
     "TGT_CMD_WRITE",
-    "TGT_CMD_ATOMIC",
+    "TGT_CMD_ATOMIC"
   };
   const char *tgt_rsp_fsm_str[] = {
@@ -72,5 +73,5 @@
     "TGT_RSP_XRAM",
     "TGT_RSP_INIT",
-    "TGT_RSP_CLEANUP",
+    "TGT_RSP_CLEANUP"
   };
   const char *init_cmd_fsm_str[] = {
@@ -88,5 +89,5 @@
     "INIT_CMD_SC_UPDT_INDEX",
     "INIT_CMD_SC_UPDT_DATA",
-    "INIT_CMD_SC_UPDT_DATA_HIGH",
+    "INIT_CMD_SC_UPDT_DATA_HIGH"
   };
   const char *init_rsp_fsm_str[] = {
@@ -94,10 +95,12 @@
     "INIT_RSP_UPT_LOCK",
     "INIT_RSP_UPT_CLEAR",
-    "INIT_RSP_END",
+    "INIT_RSP_END"
   };
   const char *read_fsm_str[] = {
     "READ_IDLE",
+    "READ_DIR_REQ",
     "READ_DIR_LOCK",
     "READ_DIR_HIT",
+    "READ_HEAP_REQ",
     "READ_HEAP_LOCK",
     "READ_HEAP_WRITE",
@@ -107,9 +110,10 @@
     "READ_TRT_LOCK",
     "READ_TRT_SET",
-    "READ_TRT_REQ",
+    "READ_TRT_REQ"
   };
   const char *write_fsm_str[] = {
     "WRITE_IDLE",
     "WRITE_NEXT",
+    "WRITE_DIR_REQ",
     "WRITE_DIR_LOCK",
     "WRITE_DIR_READ",
@@ -130,5 +134,5 @@
     "WRITE_BC_CC_SEND",
     "WRITE_BC_XRAM_REQ",
-    "WRITE_WAIT",
+    "WRITE_WAIT"
   };
   const char *ixr_rsp_fsm_str[] = {
@@ -136,5 +140,5 @@
     "IXR_RSP_ACK",
     "IXR_RSP_TRT_ERASE",
-    "IXR_RSP_TRT_READ",
+    "IXR_RSP_TRT_READ"
   };
   const char *xram_rsp_fsm_str[] = {
@@ -149,8 +153,9 @@
     "XRAM_RSP_INVAL",
     "XRAM_RSP_WRITE_DIRTY",
+    "XRAM_RSP_HEAP_REQ",
     "XRAM_RSP_HEAP_ERASE",
     "XRAM_RSP_HEAP_LAST",
     "XRAM_RSP_ERROR_ERASE",
-    "XRAM_RSP_ERROR_RSP",
+    "XRAM_RSP_ERROR_RSP"
   };
   const char *ixr_cmd_fsm_str[] = {
@@ -162,8 +167,9 @@
     "IXR_CMD_WRITE_NLINE",
     "IXR_CMD_SC_NLINE",
-    "IXR_CMD_XRAM_DATA",
+    "IXR_CMD_XRAM_DATA"
   };
   const char *sc_fsm_str[] = {
     "SC_IDLE",
+    "SC_DIR_REQ",
     "SC_DIR_LOCK",
     "SC_DIR_HIT_READ",
@@ -183,10 +189,12 @@
     "SC_MISS_TRT_SET",
     "SC_MISS_XRAM_REQ",
-    "SC_WAIT",
+    "SC_WAIT"
   };
   const char *cleanup_fsm_str[] = {
     "CLEANUP_IDLE",
+    "CLEANUP_DIR_REQ",
     "CLEANUP_DIR_LOCK",
     "CLEANUP_DIR_WRITE",
+    "CLEANUP_HEAP_REQ",
     "CLEANUP_HEAP_LOCK",
     "CLEANUP_HEAP_SEARCH",
@@ -196,12 +204,13 @@
     "CLEANUP_UPT_WRITE",
     "CLEANUP_WRITE_RSP",
-    "CLEANUP_RSP",
+    "CLEANUP_RSP"
   };
   const char *alloc_dir_fsm_str[] = {
+    "ALLOC_DIR_RESET",
     "ALLOC_DIR_READ",
     "ALLOC_DIR_WRITE",
     "ALLOC_DIR_SC",
     "ALLOC_DIR_CLEANUP",
-    "ALLOC_DIR_XRAM_RSP",
+    "ALLOC_DIR_XRAM_RSP"
   };
   const char *alloc_trt_fsm_str[] = {
@@ -210,5 +219,5 @@
     "ALLOC_TRT_SC",
     "ALLOC_TRT_XRAM_RSP",
-    "ALLOC_TRT_IXR_RSP",
+    "ALLOC_TRT_IXR_RSP"
   };
   const char *alloc_upt_fsm_str[] = {
@@ -217,11 +226,13 @@
     "ALLOC_UPT_INIT_RSP",
     "ALLOC_UPT_CLEANUP",
+    "ALLOC_UPT_SC"
   };
   const char *alloc_heap_fsm_str[] = {
+    "ALLOC_HEAP_RESET",
     "ALLOC_HEAP_READ",
     "ALLOC_HEAP_WRITE",
     "ALLOC_HEAP_SC",
     "ALLOC_HEAP_CLEANUP",
-    "ALLOC_HEAP_XRAM_RSP",
+    "ALLOC_HEAP_XRAM_RSP"
   };
 
@@ -231,8 +242,8 @@
 
   ////////////////////////////////
-  // 	Constructor 
+  //  Constructor
   ////////////////////////////////
 
-  tmpl(/**/)::VciMemCacheV4( 
+  tmpl(/**/)::VciMemCacheV4(
       sc_module_name name,
       const soclib::common::MappingTable &mtp,
@@ -243,10 +254,10 @@
       const soclib::common::IntTab &vci_tgt_index,
       const soclib::common::IntTab &vci_tgt_index_cleanup,
-      size_t nways,                                         // number of ways per set
-      size_t nsets,                                         // number of cache sets
-      size_t nwords,                                        // number of words in cache line
-      size_t heap_size,                                     // number of heap entries
-      size_t transaction_tab_lines,                         // number of TRT entries
-      size_t update_tab_lines,                              // number of UPT entries
+      size_t nways,                 // number of ways per set
+      size_t nsets,                 // number of cache sets
+      size_t nwords,                // number of words in cache line
+      size_t heap_size,             // number of heap entries
+      size_t transaction_tab_lines, // number of TRT entries
+      size_t update_tab_lines,      // number of UPT entries
       size_t debug_start_cycle,
       bool   debug_ok)
@@ -287,5 +298,5 @@
 #undef L2
 
-    //  FIFOs 
+    //  FIFOs
 
     m_cmd_read_addr_fifo("m_cmd_read_addr_fifo", 4),
@@ -311,7 +322,7 @@
 
     r_tgt_cmd_fsm("r_tgt_cmd_fsm"),
-    
-    m_nseg(0),	
-    m_ncseg(0),	
+
+    m_nseg(0),
+    m_ncseg(0),
 
     r_read_fsm("r_read_fsm"),
@@ -352,7 +363,9 @@
 
     r_alloc_dir_fsm("r_alloc_dir_fsm"),
+    r_alloc_dir_reset_cpt("r_alloc_dir_reset_cpt"),
     r_alloc_trt_fsm("r_alloc_trt_fsm"),
     r_alloc_upt_fsm("r_alloc_upt_fsm"),
-    r_alloc_heap_fsm("r_alloc_heap_fsm")
+    r_alloc_heap_fsm("r_alloc_heap_fsm"),
+    r_alloc_heap_reset_cpt("r_alloc_heap_reset_cpt")
     {
       assert(IS_POW_OF_2(nsets));
@@ -370,5 +383,5 @@
       m_broadcast_address = 0x3 | (0x7C1F << (vci_param::N-20));
 
-      // Get the segments associated to the MemCache 
+      // Get the segments associated to the MemCache
       std::list<soclib::common::Segment>::iterator seg;
       size_t i;
@@ -384,5 +397,5 @@
 
       i = 0;
-      for ( seg = m_seglist.begin() ; seg != m_seglist.end() ; seg++ ) { 
+      for ( seg = m_seglist.begin() ; seg != m_seglist.end() ; seg++ ) {
         m_seg[i] = &(*seg);
         i++;
@@ -392,5 +405,5 @@
 
       i = 0;
-      for ( seg = m_cseglist.begin() ; seg != m_cseglist.end() ; seg++ ) { 
+      for ( seg = m_cseglist.begin() ; seg != m_cseglist.end() ; seg++ ) {
           m_cseg[i] = &(*seg);
           i++;
@@ -407,30 +420,30 @@
           for ( size_t k=0; k<nwords; k++){
             m_cache_data[i][j][k]=0;
-          }	
+          }
         }
       }
 
       // Allocation for IXR_RSP FSM
-      r_ixr_rsp_to_xram_rsp_rok	    = new sc_signal<bool>[m_transaction_tab_lines];
+      r_ixr_rsp_to_xram_rsp_rok   = new sc_signal<bool>[m_transaction_tab_lines];
 
       // Allocation for XRAM_RSP FSM
-      r_xram_rsp_victim_data        = new sc_signal<data_t>[nwords];
-      r_xram_rsp_to_tgt_rsp_data    = new sc_signal<data_t>[nwords];
-      r_xram_rsp_to_ixr_cmd_data    = new sc_signal<data_t>[nwords];
+      r_xram_rsp_victim_data      = new sc_signal<data_t>[nwords];
+      r_xram_rsp_to_tgt_rsp_data  = new sc_signal<data_t>[nwords];
+      r_xram_rsp_to_ixr_cmd_data  = new sc_signal<data_t>[nwords];
 
       // Allocation for READ FSM
-      r_read_data 			        = new sc_signal<data_t>[nwords];
-      r_read_to_tgt_rsp_data 		= new sc_signal<data_t>[nwords];
+      r_read_data                 = new sc_signal<data_t>[nwords];
+      r_read_to_tgt_rsp_data      = new sc_signal<data_t>[nwords];
 
       // Allocation for WRITE FSM
-      r_write_data 			        = new sc_signal<data_t>[nwords];
-      r_write_be 			        = new sc_signal<be_t>[nwords];
-      r_write_to_init_cmd_data 		= new sc_signal<data_t>[nwords];
-      r_write_to_init_cmd_be		= new sc_signal<be_t>[nwords];
-      r_write_to_ixr_cmd_data	    = new sc_signal<data_t>[nwords];
+      r_write_data                = new sc_signal<data_t>[nwords];
+      r_write_be                  = new sc_signal<be_t>[nwords];
+      r_write_to_init_cmd_data    = new sc_signal<data_t>[nwords];
+      r_write_to_init_cmd_be      = new sc_signal<be_t>[nwords];
+      r_write_to_ixr_cmd_data     = new sc_signal<data_t>[nwords];
 
       // Allocation for SC FSM
-      r_sc_to_ixr_cmd_data	        = new sc_signal<data_t>[nwords];
-      r_sc_rdata                    = new sc_signal<data_t>[2];
+      r_sc_to_ixr_cmd_data        = new sc_signal<data_t>[nwords];
+      r_sc_rdata                  = new sc_signal<data_t>[2];
 
 
@@ -471,5 +484,5 @@
     {
         std::cout << " MEMC Write Monitor : " << buf << " Address = " << std::hex << addr
-                  << " / Data = " << data << std::endl; 
+                  << " / Data = " << data << std::endl;
     }
 }
@@ -480,5 +493,5 @@
 {
     DirectoryEntry entry = m_cache_directory.read_neutral(addr);
-    if ( (entry.count != m_debug_previous_count) or 
+    if ( (entry.count != m_debug_previous_count) or
          (entry.valid != m_debug_previous_hit) )
     {
@@ -498,13 +511,13 @@
 {
     std::cout << "MEMC " << name() << std::endl;
-    std::cout << "  "  << tgt_cmd_fsm_str[r_tgt_cmd_fsm] 
-              << " | " << tgt_rsp_fsm_str[r_tgt_rsp_fsm] 
+    std::cout << "  "  << tgt_cmd_fsm_str[r_tgt_cmd_fsm]
+              << " | " << tgt_rsp_fsm_str[r_tgt_rsp_fsm]
               << " | " << read_fsm_str[r_read_fsm]
-              << " | " << write_fsm_str[r_write_fsm] 
-              << " | " << sc_fsm_str[r_sc_fsm] 
+              << " | " << write_fsm_str[r_write_fsm]
+              << " | " << sc_fsm_str[r_sc_fsm]
               << " | " << cleanup_fsm_str[r_cleanup_fsm] << std::endl;
     std::cout << "  "  << init_cmd_fsm_str[r_init_cmd_fsm]
-              << " | " << init_rsp_fsm_str[r_init_rsp_fsm] 
-              << " | " << ixr_cmd_fsm_str[r_ixr_cmd_fsm] 
+              << " | " << init_rsp_fsm_str[r_init_rsp_fsm]
+              << " | " << ixr_cmd_fsm_str[r_ixr_cmd_fsm]
               << " | " << ixr_rsp_fsm_str[r_ixr_rsp_fsm]
               << " | " << xram_rsp_fsm_str[r_xram_rsp_fsm] << std::endl;
@@ -515,25 +528,26 @@
 /////////////////////////////////////////
 {
-    std::cout << "----------------------------------" << std::dec << std::endl;
-    std::cout << "MEM_CACHE " << m_srcid_ini << " / Time = " << m_cpt_cycles << std::endl
-              << "- READ RATE            = " << (double)m_cpt_read/m_cpt_cycles << std::endl
-              << "- READ TOTAL           = " << m_cpt_read << std::endl
-              << "- READ MISS RATE       = " << (double)m_cpt_read_miss/m_cpt_read << std::endl
-              << "- WRITE RATE           = " << (double)m_cpt_write/m_cpt_cycles << std::endl
-              << "- WRITE TOTAL          = " << m_cpt_write << std::endl
-              << "- WRITE MISS RATE      = " << (double)m_cpt_write_miss/m_cpt_write << std::endl
-              << "- WRITE BURST LENGTH   = " << (double)m_cpt_write_cells/m_cpt_write << std::endl
-              << "- WRITE BURST TOTAL    = " << m_cpt_write_cells << std::endl
-              << "- REQUESTS TRT FULL    = " << m_cpt_trt_full << std::endl
-              << "- READ TRT BLOKED HIT  = " << m_cpt_trt_rb << std::endl
-              << "- UPDATE RATE          = " << (double)m_cpt_update/m_cpt_cycles << std::endl
-              << "- UPDATE ARITY         = " << (double)m_cpt_update_mult/m_cpt_update << std::endl
-              << "- INVAL MULTICAST RATE = " << (double)(m_cpt_inval-m_cpt_inval_brdcast)/m_cpt_cycles << std::endl
-              << "- INVAL MULTICAST ARITY= " << (double)m_cpt_inval_mult/(m_cpt_inval-m_cpt_inval_brdcast) << std::endl
-              << "- INVAL BROADCAST RATE = " << (double)m_cpt_inval_brdcast/m_cpt_cycles << std::endl
-              << "- SAVE DIRTY RATE      = " << (double)m_cpt_write_dirty/m_cpt_cycles << std::endl
-              << "- CLEANUP RATE         = " << (double)m_cpt_cleanup/m_cpt_cycles << std::endl
-              << "- LL RATE              = " << (double)m_cpt_ll/m_cpt_cycles << std::endl
-              << "- SC RATE              = " << (double)m_cpt_sc/m_cpt_cycles << std::endl;
+  std::cout << "----------------------------------" << std::dec << std::endl;
+  std::cout
+    << "MEM_CACHE " << m_srcid_ini << " / Time = " << m_cpt_cycles << std::endl
+    << "- READ RATE            = " << (double) m_cpt_read/m_cpt_cycles << std::endl
+    << "- READ TOTAL           = " << m_cpt_read << std::endl
+    << "- READ MISS RATE       = " << (double) m_cpt_read_miss/m_cpt_read << std::endl
+    << "- WRITE RATE           = " << (double) m_cpt_write/m_cpt_cycles << std::endl
+    << "- WRITE TOTAL          = " << m_cpt_write << std::endl
+    << "- WRITE MISS RATE      = " << (double) m_cpt_write_miss/m_cpt_write << std::endl
+    << "- WRITE BURST LENGTH   = " << (double) m_cpt_write_cells/m_cpt_write << std::endl
+    << "- WRITE BURST TOTAL    = " << m_cpt_write_cells << std::endl
+    << "- REQUESTS TRT FULL    = " << m_cpt_trt_full << std::endl
+    << "- READ TRT BLOKED HIT  = " << m_cpt_trt_rb << std::endl
+    << "- UPDATE RATE          = " << (double) m_cpt_update/m_cpt_cycles << std::endl
+    << "- UPDATE ARITY         = " << (double) m_cpt_update_mult/m_cpt_update << std::endl
+    << "- INVAL MULTICAST RATE = " << (double) (m_cpt_inval-m_cpt_inval_brdcast)/m_cpt_cycles << std::endl
+    << "- INVAL MULTICAST ARITY= " << (double) m_cpt_inval_mult/(m_cpt_inval-m_cpt_inval_brdcast) << std::endl
+    << "- INVAL BROADCAST RATE = " << (double) m_cpt_inval_brdcast/m_cpt_cycles << std::endl
+    << "- SAVE DIRTY RATE      = " << (double) m_cpt_write_dirty/m_cpt_cycles << std::endl
+    << "- CLEANUP RATE         = " << (double) m_cpt_cleanup/m_cpt_cycles << std::endl
+    << "- LL RATE              = " << (double) m_cpt_ll/m_cpt_cycles << std::endl
+    << "- SC RATE              = " << (double) m_cpt_sc/m_cpt_cycles << std::endl;
 }
 
@@ -570,194 +584,198 @@
 //////////////////////////////////
 {
-    using soclib::common::uint32_log2;
-
-    //  RESET          
-    if ( ! p_resetn.read() ) {
-
-      //     Initializing FSMs
-      r_tgt_cmd_fsm 	= TGT_CMD_IDLE;
-      r_tgt_rsp_fsm 	= TGT_RSP_READ_IDLE;
-      r_init_cmd_fsm 	= INIT_CMD_INVAL_IDLE;
-      r_init_rsp_fsm 	= INIT_RSP_IDLE;
-      r_read_fsm 	    = READ_IDLE;
-      r_write_fsm 	    = WRITE_IDLE;
-      r_sc_fsm 	        = SC_IDLE;
-      r_cleanup_fsm 	= CLEANUP_IDLE;
-      r_alloc_dir_fsm   = ALLOC_DIR_READ;
-      r_alloc_heap_fsm  = ALLOC_HEAP_READ;
-      r_alloc_trt_fsm   = ALLOC_TRT_READ;
-      r_alloc_upt_fsm   = ALLOC_UPT_WRITE;
-      r_ixr_rsp_fsm 	= IXR_RSP_IDLE;
-      r_xram_rsp_fsm 	= XRAM_RSP_IDLE;
-      r_ixr_cmd_fsm 	= IXR_CMD_READ_IDLE;
-
-      m_debug_global         = false;
-      m_debug_tgt_cmd_fsm    = false;
-      m_debug_tgt_rsp_fsm    = false;
-      m_debug_init_cmd_fsm   = false;
-      m_debug_init_rsp_fsm   = false;
-      m_debug_read_fsm       = false;
-      m_debug_write_fsm      = false;
-      m_debug_sc_fsm         = false;
-      m_debug_cleanup_fsm    = false;
-      m_debug_ixr_cmd_fsm    = false;
-      m_debug_ixr_rsp_fsm    = false;
-      m_debug_xram_rsp_fsm   = false;
-      m_debug_previous_hit   = false;
-      m_debug_previous_count = 0;
-
-      //  Initializing Tables
-      m_cache_directory.init();
-      m_transaction_tab.init();
-      m_heap.init();
-
-      // initializing FIFOs and communication Buffers
-
-      m_cmd_read_addr_fifo.init();
-      m_cmd_read_length_fifo.init();
-      m_cmd_read_srcid_fifo.init();
-      m_cmd_read_trdid_fifo.init();
-      m_cmd_read_pktid_fifo.init();
-
-      m_cmd_write_addr_fifo.init();
-      m_cmd_write_eop_fifo.init();
-      m_cmd_write_srcid_fifo.init();
-      m_cmd_write_trdid_fifo.init();
-      m_cmd_write_pktid_fifo.init();
-      m_cmd_write_data_fifo.init();
-
-      m_cmd_sc_addr_fifo.init();
-      m_cmd_sc_srcid_fifo.init();
-      m_cmd_sc_trdid_fifo.init();
-      m_cmd_sc_pktid_fifo.init();
-      m_cmd_sc_wdata_fifo.init();
-      m_cmd_sc_eop_fifo.init();
-
-      r_read_to_tgt_rsp_req	            = false;
-      r_read_to_ixr_cmd_req	            = false;
-
-      r_write_to_tgt_rsp_req	        = false;
-      r_write_to_ixr_cmd_req	        = false;
-      r_write_to_init_cmd_multi_req	    = false;
-      r_write_to_init_cmd_brdcast_req	= false;
-      r_write_to_init_rsp_req           = false;
-      m_write_to_init_cmd_inst_fifo.init();
-      m_write_to_init_cmd_srcid_fifo.init();
+  using soclib::common::uint32_log2;
+
+  // RESET
+  if ( ! p_resetn.read() ) {
+
+    // Initializing FSMs
+    r_tgt_cmd_fsm    = TGT_CMD_IDLE;
+    r_tgt_rsp_fsm    = TGT_RSP_READ_IDLE;
+    r_init_cmd_fsm   = INIT_CMD_INVAL_IDLE;
+    r_init_rsp_fsm   = INIT_RSP_IDLE;
+    r_read_fsm       = READ_IDLE;
+    r_write_fsm      = WRITE_IDLE;
+    r_sc_fsm         = SC_IDLE;
+    r_cleanup_fsm    = CLEANUP_IDLE;
+    r_alloc_dir_fsm  = ALLOC_DIR_RESET;
+    r_alloc_heap_fsm = ALLOC_HEAP_RESET;
+    r_alloc_trt_fsm  = ALLOC_TRT_READ;
+    r_alloc_upt_fsm  = ALLOC_UPT_WRITE;
+    r_ixr_rsp_fsm    = IXR_RSP_IDLE;
+    r_xram_rsp_fsm   = XRAM_RSP_IDLE;
+    r_ixr_cmd_fsm    = IXR_CMD_READ_IDLE;
+
+    m_debug_global         = false;
+    m_debug_tgt_cmd_fsm    = false;
+    m_debug_tgt_rsp_fsm    = false;
+    m_debug_init_cmd_fsm   = false;
+    m_debug_init_rsp_fsm   = false;
+    m_debug_read_fsm       = false;
+    m_debug_write_fsm      = false;
+    m_debug_sc_fsm         = false;
+    m_debug_cleanup_fsm    = false;
+    m_debug_ixr_cmd_fsm    = false;
+    m_debug_ixr_rsp_fsm    = false;
+    m_debug_xram_rsp_fsm   = false;
+    m_debug_previous_hit   = false;
+    m_debug_previous_count = 0;
+
+    //  Initializing Tables
+    m_transaction_tab.init();
+    m_update_tab.init();
+
+    // initializing FIFOs and communication Buffers
+
+    m_cmd_read_addr_fifo.init();
+    m_cmd_read_length_fifo.init();
+    m_cmd_read_srcid_fifo.init();
+    m_cmd_read_trdid_fifo.init();
+    m_cmd_read_pktid_fifo.init();
+
+    m_cmd_write_addr_fifo.init();
+    m_cmd_write_eop_fifo.init();
+    m_cmd_write_srcid_fifo.init();
+    m_cmd_write_trdid_fifo.init();
+    m_cmd_write_pktid_fifo.init();
+    m_cmd_write_data_fifo.init();
+
+    m_cmd_sc_addr_fifo.init();
+    m_cmd_sc_srcid_fifo.init();
+    m_cmd_sc_trdid_fifo.init();
+    m_cmd_sc_pktid_fifo.init();
+    m_cmd_sc_wdata_fifo.init();
+    m_cmd_sc_eop_fifo.init();
+
+    r_read_to_tgt_rsp_req = false;
+    r_read_to_ixr_cmd_req = false;
+
+    r_write_to_tgt_rsp_req          = false;
+    r_write_to_ixr_cmd_req          = false;
+    r_write_to_init_cmd_multi_req   = false;
+    r_write_to_init_cmd_brdcast_req = false;
+    r_write_to_init_rsp_req         = false;
+
+    m_write_to_init_cmd_inst_fifo.init();
+    m_write_to_init_cmd_srcid_fifo.init();
 #if L1_MULTI_CACHE
-      m_write_to_init_cmd_cache_id_fifo.init();
-#endif
-
-      r_cleanup_to_tgt_rsp_req	        = false;
-
-      r_init_rsp_to_tgt_rsp_req	        = false;
-
-      r_sc_to_tgt_rsp_req	            = false;
-      r_sc_cpt                          = 0;
-      r_sc_lfsr                         = -1;
-      r_sc_to_ixr_cmd_req	            = false;
-      r_sc_to_init_cmd_multi_req	    = false;
-      r_sc_to_init_cmd_brdcast_req	    = false;
-      m_sc_to_init_cmd_inst_fifo.init();
-      m_sc_to_init_cmd_srcid_fifo.init();
+    m_write_to_init_cmd_cache_id_fifo.init();
+#endif
+
+    r_cleanup_to_tgt_rsp_req     = false;
+
+    r_init_rsp_to_tgt_rsp_req    = false;
+
+    r_sc_to_tgt_rsp_req          = false;
+    r_sc_cpt                     = 0;
+    r_sc_lfsr                    = -1;
+    r_sc_to_ixr_cmd_req          = false;
+    r_sc_to_init_cmd_multi_req   = false;
+    r_sc_to_init_cmd_brdcast_req = false;
+
+    m_sc_to_init_cmd_inst_fifo.init();
+    m_sc_to_init_cmd_srcid_fifo.init();
 #if L1_MULTI_CACHE
-      m_sc_to_init_cmd_cache_id_fifo.init();
-#endif
-
-      for(size_t i=0; i<m_transaction_tab_lines ; i++){
-        r_ixr_rsp_to_xram_rsp_rok[i] = false;
-      }
-
-      r_xram_rsp_to_tgt_rsp_req	            = false;
-      r_xram_rsp_to_init_cmd_multi_req      = false;
-      r_xram_rsp_to_init_cmd_brdcast_req    = false;
-      r_xram_rsp_to_ixr_cmd_req	            = false;
-      r_xram_rsp_trt_index	                = 0;
-      m_xram_rsp_to_init_cmd_inst_fifo.init();
-      m_xram_rsp_to_init_cmd_srcid_fifo.init();
+    m_sc_to_init_cmd_cache_id_fifo.init();
+#endif
+
+    for(size_t i=0; i<m_transaction_tab_lines ; i++){
+      r_ixr_rsp_to_xram_rsp_rok[i] = false;
+    }
+
+    r_xram_rsp_to_tgt_rsp_req          = false;
+    r_xram_rsp_to_init_cmd_multi_req   = false;
+    r_xram_rsp_to_init_cmd_brdcast_req = false;
+    r_xram_rsp_to_ixr_cmd_req          = false;
+    r_xram_rsp_trt_index               = 0;
+
+    m_xram_rsp_to_init_cmd_inst_fifo.init();
+    m_xram_rsp_to_init_cmd_srcid_fifo.init();
 #if L1_MULTI_CACHE
-      m_xram_rsp_to_init_cmd_cache_id_fifo.init();
-#endif
-
-      r_ixr_cmd_cpt         = 0;
-
-      r_copies_limit        = 3;
-
-      // Activity counters
-      m_cpt_cycles		    = 0;
-      m_cpt_read		    = 0;
-      m_cpt_read_miss	    = 0;
-      m_cpt_write		    = 0;
-      m_cpt_write_miss	    = 0;
-      m_cpt_write_cells	    = 0;
-      m_cpt_write_dirty	    = 0;
-      m_cpt_update		    = 0;
-      m_cpt_update_mult     = 0;
-      m_cpt_inval_brdcast 	= 0;
-      m_cpt_inval 		    = 0;
-      m_cpt_inval_mult 		= 0;
-      m_cpt_cleanup		    = 0;
-      m_cpt_ll     		    = 0;
-      m_cpt_sc     		    = 0;
-      m_cpt_trt_full        = 0;
-      m_cpt_trt_rb          = 0;
-
-      return;
-    }
-
-    bool    cmd_read_fifo_put = false;
-    bool    cmd_read_fifo_get = false;
-
-    bool    cmd_write_fifo_put = false;
-    bool    cmd_write_fifo_get = false;
-
-    bool    cmd_sc_fifo_put = false;
-    bool    cmd_sc_fifo_get = false;
-
-    bool    write_to_init_cmd_fifo_put      = false;
-    bool    write_to_init_cmd_fifo_get      = false;
-    bool    write_to_init_cmd_fifo_inst     = false;
-    size_t  write_to_init_cmd_fifo_srcid    = 0;
+    m_xram_rsp_to_init_cmd_cache_id_fifo.init();
+#endif
+
+    r_ixr_cmd_cpt          = 0;
+    r_alloc_dir_reset_cpt  = 0;
+    r_alloc_heap_reset_cpt = 0;
+
+    r_copies_limit         = 3;
+
+    // Activity counters
+    m_cpt_cycles        = 0;
+    m_cpt_read          = 0;
+    m_cpt_read_miss     = 0;
+    m_cpt_write         = 0;
+    m_cpt_write_miss    = 0;
+    m_cpt_write_cells   = 0;
+    m_cpt_write_dirty   = 0;
+    m_cpt_update        = 0;
+    m_cpt_update_mult   = 0;
+    m_cpt_inval_brdcast = 0;
+    m_cpt_inval         = 0;
+    m_cpt_inval_mult    = 0;
+    m_cpt_cleanup       = 0;
+    m_cpt_ll            = 0;
+    m_cpt_sc            = 0;
+    m_cpt_trt_full      = 0;
+    m_cpt_trt_rb        = 0;
+
+    return;
+  }
+
+  bool    cmd_read_fifo_put = false;
+  bool    cmd_read_fifo_get = false;
+
+  bool    cmd_write_fifo_put = false;
+  bool    cmd_write_fifo_get = false;
+
+  bool    cmd_sc_fifo_put = false;
+  bool    cmd_sc_fifo_get = false;
+
+  bool    write_to_init_cmd_fifo_put   = false;
+  bool    write_to_init_cmd_fifo_get   = false;
+  bool    write_to_init_cmd_fifo_inst  = false;
+  size_t  write_to_init_cmd_fifo_srcid = 0;
 
 #if L1_MULTI_CACHE
-    size_t  write_to_init_cmd_fifo_cache_id = 0;
-#endif
-
-    bool    xram_rsp_to_init_cmd_fifo_put      = false;
-    bool    xram_rsp_to_init_cmd_fifo_get      = false;
-    bool    xram_rsp_to_init_cmd_fifo_inst     = false;
-    size_t  xram_rsp_to_init_cmd_fifo_srcid    = 0;
+  size_t  write_to_init_cmd_fifo_cache_id = 0;
+#endif
+
+  bool    xram_rsp_to_init_cmd_fifo_put   = false;
+  bool    xram_rsp_to_init_cmd_fifo_get   = false;
+  bool    xram_rsp_to_init_cmd_fifo_inst  = false;
+  size_t  xram_rsp_to_init_cmd_fifo_srcid = 0;
 
 #if L1_MULTI_CACHE
-    size_t  xram_rsp_to_init_cmd_fifo_cache_id = 0;
-#endif
-
-    bool    sc_to_init_cmd_fifo_put      = false;
-    bool    sc_to_init_cmd_fifo_get      = false;
-    bool    sc_to_init_cmd_fifo_inst     = false;
-    size_t  sc_to_init_cmd_fifo_srcid    = 0;
+  size_t  xram_rsp_to_init_cmd_fifo_cache_id = 0;
+#endif
+
+  bool    sc_to_init_cmd_fifo_put   = false;
+  bool    sc_to_init_cmd_fifo_get   = false;
+  bool    sc_to_init_cmd_fifo_inst  = false;
+  size_t  sc_to_init_cmd_fifo_srcid = 0;
 
 #if L1_MULTI_CACHE
-    size_t  sc_to_init_cmd_fifo_cache_id = 0;
-#endif
-
-m_debug_global       = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
-m_debug_tgt_cmd_fsm  = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
-m_debug_tgt_rsp_fsm  = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
-m_debug_init_cmd_fsm = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
-m_debug_init_rsp_fsm = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
-m_debug_read_fsm     = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
-m_debug_write_fsm    = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
-m_debug_sc_fsm       = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
-m_debug_cleanup_fsm  = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
-m_debug_ixr_cmd_fsm  = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
-m_debug_ixr_rsp_fsm  = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
-m_debug_xram_rsp_fsm = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
-
-
-#if DEBUG_MEMC_GLOBAL   
-if( m_debug_global ) 
-{
-    std::cout << "---------------------------------------------" << std::dec << std::endl;
-    std::cout << "MEM_CACHE " << m_srcid_ini << " ; Time = " << m_cpt_cycles << std::endl
+  size_t  sc_to_init_cmd_fifo_cache_id = 0;
+#endif
+
+  m_debug_global       = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
+  m_debug_tgt_cmd_fsm  = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
+  m_debug_tgt_rsp_fsm  = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
+  m_debug_init_cmd_fsm = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
+  m_debug_init_rsp_fsm = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
+  m_debug_read_fsm     = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
+  m_debug_write_fsm    = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
+  m_debug_sc_fsm       = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
+  m_debug_cleanup_fsm  = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
+  m_debug_ixr_cmd_fsm  = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
+  m_debug_ixr_rsp_fsm  = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
+  m_debug_xram_rsp_fsm = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
+
+#if DEBUG_MEMC_GLOBAL
+  if( m_debug_global )
+  {
+    std::cout
+      << "---------------------------------------------" << std::dec << std::endl
+      << "MEM_CACHE " << m_srcid_ini << " ; Time = " << m_cpt_cycles << std::endl
       << " - TGT_CMD FSM    = " << tgt_cmd_fsm_str[r_tgt_cmd_fsm] << std::endl
       << " - TGT_RSP FSM    = " << tgt_rsp_fsm_str[r_tgt_rsp_fsm] << std::endl
